function BabelFishTranslationService()
{
	var dictionary = new Array();
	var updateFunction;
	
	BabelFishTranslationService.prototype.getLanguageDictionary = 
		getLanguageDictionary;
	BabelFishTranslationService.prototype.translate = translate;
	
	// Initialise the dictionary array.
	dictionary["Chinese (Simplified)"] = ["zh", ["English"]];
	dictionary["Chinese (Traditional)"] = ["zt", ["English"]];
	dictionary["English"] = ["en", ["Chinese (Simplified)",
		"Chinese (Traditional)", "Dutch", "French", "German", "Greek",
		"Italian", "Japanese", "Korean", "Portuguese", "Russian", "Spanish"]];
	dictionary["Dutch"] = ["nl", ["English", "French"]];
	dictionary["French"] = ["fr", ["Dutch", "English", "German", "Greek",
		"Italian", "Portuguese", "Spanish"]];
	dictionary["German"] = ["de", ["English", "French"]];
	dictionary["Greek"] = ["el", ["English", "French"]];
	dictionary["Italian"] = ["it", ["English", "French"]];
	dictionary["Japanese"] = ["ja", ["English"]];
	dictionary["Korean"] = ["ko", ["English"]];
	dictionary["Portuguese"] = ["pt", ["English", "French"]];
	dictionary["Russian"] = ["ru", ["English"]];
	dictionary["Spanish"] = ["es", ["English", "French"]];
	
	function getLanguageDictionary()
	{
		return dictionary;
	}
	
	function translate(fromLanguage, toLanguage, text, update)
	{
		updateFunction = update;
		
		var url = new URL();
		url.location = "http://babelfish.altavista.com/tr";
		
		var lp = dictionary[fromLanguage][0] + "_" + dictionary[toLanguage][0];
		var urltext = escape(text);
		
		url.postData = "doit=done&intl=1&tt=urltext&trtext=" + urltext + "&lp=" + lp;
		url.fetchAsync(urlDone);
	}
	
	function urlDone(url)
	{
		if (url.response != 0 && url.response < 400)
		{
			page = url.result;
			
			var startPosition = page.indexOf("<div style=padding:10px;>") + 25;
			var endPosition = page.indexOf("</div>", startPosition + 1);
			var translatedText = page.substring(startPosition, endPosition);
			
			updateFunction(translatedText);
		}
		else
		{
			alert("There was an error while connecting to the server. Please " +
				"check your Internet connection before trying again.");
			
			updateFunction("");
		}
		
		delete url;
	}
}