function hideLanguagePanel1()
{
	var a = new FadeAnimation(frame1, 0, 150, animator.kEaseOut);
	animator.runUntilDone(a);
	
	for (i = 0; i < languageOptions.length; i++)
	{
		languageOptions[i].removeFromSuperview();
		delete languageOptions[i];
	}
	languageOptions = new Array();
	
	slidedown1.slide("up", 100, 3);
	isDown1 = false;
	
	delete a;
	
	frame1.zOrder = 10;
}

function hideLanguagePanel2()
{
	var a = new FadeAnimation(frame2, 0, 150, animator.kEaseOut);
	animator.runUntilDone(a);
	
	for (i = 0; i < languageOptions.length; i++)
	{
		languageOptions[i].removeFromSuperview();
		delete languageOptions[i];
	}
	languageOptions = new Array();
	
	slidedown2.slide("up", 100, 3);
	isDown2 = false;
	
	delete a;
	
	frame2.zOrder = 10;
}

function hideServicesPanel()
{	
	// Animate text exit.
	var a = new FadeAnimation(services1, 0, 100, animator.kEaseOut);
	var b = new FadeAnimation(services2, 0, 100, animator.kEaseOut);
	var c = new FadeAnimation(altavista, 0, 100, animator.kEaseOut);
	var d = new FadeAnimation(systran, 0, 100, animator.kEaseOut);
	var e = new FadeAnimation(sdlInternational, 0, 100, animator.kEaseOut);
	var f = new FadeAnimation(service_site, 0, 100, animator.kEaseOut);
	var g = new FadeAnimation(icon_outline, 0, 100, animator.kEaseOut);
	var h = new FadeAnimation(icon_highlight, 0, 100, animator.kEaseOut);
	animator.runUntilDone([a, b, c, d, e, f, g, h]);
	
	altavista.visible = systran.visible = sdlInternational.visible = 
		icon_outline.visible = icon_highlight.visible = false;
	
	services_slidedown.slide("up", 100, 4);
	isDownServices = false;
	translating = false;
	
	// Enable text boxes.
	text1.editable = true;
	text2.editable = true;
}

function contains(array, searchItem)
{
	var found = false;
	var i = 0;
	
	while (!found && i < array.length)
	{
		if (array[i] == searchItem)
			found = true;
		
		i++;
	}
	
	return found;
}

function saveLanguagePrefs(language1, language2)
{
	preferences.language1.value = "Resources/Images/Languages/" +
		language1 + ".png";
	preferences.language2.value = "Resources/Images/Languages/" +
		language2 + ".png";
}

function ensureCompatibleLanguage()
{
	var language1 = languageText1.src.substring(27, languageText1.src.length - 4);
	var language2 = languageText2.src.substring(27, languageText2.src.length - 4);
	
	if (contains(languageDictionary[language1][1], language2))
		saveLanguagePrefs(language1, language2);
	else if (contains(languageDictionary[language1][1], "English"))
	{
		languageText2.src = "Resources/Images/Languages/English.png";
		saveLanguagePrefs(language1, "English");
	}
	else if (contains(languageDictionary[language1][1], "French"))
	{
		languageText2.src = "Resources/Images/Languages/French.png";
		saveLanguagePrefs(language1, "French");
	}
	else
	{
		languageText2.src = "Resources/Images/Languages/" +
			languageDictionary[language1][1][0] + ".png";
		saveLanguagePrefs(language1, languageDictionary[language1][1][0]);
	}
}

function checkLanguageAvailability()
{
	var language1 = languageText1.src.substring(27, languageText1.src.length - 4);
	var language2 = languageText2.src.substring(27, languageText2.src.length - 4);
	
	if (languageDictionary[language1] == undefined ||
		languageDictionary[language1][1].length == 0)
	{
		languageText1.src = "Resources/Images/Languages/English.png";
		languageText2.src = "Resources/Images/Languages/French.png";
		saveLanguagePrefs("English", "French");
	}
	else if (!contains(languageDictionary[language1][1], language2))
	{
		if (contains(languageDictionary[language1][1], "English"))
		{
			languageText2.src = "Resources/Images/Languages/English.png";
			saveLanguagePrefs(language1, "English");
		}
		else if (contains(languageDictionary[language1][1], "French"))
		{
			languageText2.src = "Resources/Images/Languages/French.png";
			saveLanguagePrefs(language1, "French");
		}
		else
		{
			languageText2.src = "Resources/Images/Languages/" +
				languageDictionary[language1][1][0] + ".png";
			saveLanguagePrefs(language1, languageDictionary[language1][1][0]);
		}
	}
	
	fixArrowButtons();
}

function updateLeft(translatedText)
{
	text1.data = translatedText.replace("&#39;", "'", "g");
	
	// Hide the translating slider.
	var a = new FadeAnimation(translating1, 0, 80, animator.kEaseOut);
	var b = new FadeAnimation(spinner1, 0, 80, animator.kEaseOut);
	animator.start([a, b]);
	sleep(80);
	
	// Remove image's source to (hopefully) make it disappear.
	spinner1.src = null;
	spinner1.visible = false;
	translating1.visible = false;
	
	slidedown1.slide("up", 100, 3);
	translating = false;
	
	text1.select(-1, -1);
}

function updateRight(translatedText)
{
	text2.data = translatedText.replace("&#39;", "'", "g");
	
	// Hide the translating slider.
	var a = new FadeAnimation(translating2, 0, 80, animator.kEaseOut);
	var b = new FadeAnimation(spinner2, 0, 80, animator.kEaseOut);
	animator.start([a, b]);
	sleep(80);
	
	// Remove image's source to (hopefully) make it disappear.
	spinner2.src = null;
	spinner2.visible = false;
	translating2.visible = false;
	
	slidedown2.slide("up", 100, 3);
	translating = false;
	
	text2.select(-1, -1);
}

function fixArrowButtons()
{
	var language1 = languageText1.src.substring(27, languageText1.src.length - 4);
	var language2 = languageText2.src.substring(27, languageText2.src.length - 4);
	
	if (!contains(languageDictionary[language2][1], language1))
		leftArrow.opacity = 80;
	else
		leftArrow.opacity = 255;
		
	delete language1, language2;
}

function configureScrollbars()
{
	scroller1.setTrackInfo(0, 0, 0, "Resources/Images/ScrollBarTrack.png");
	scroller1.setThumbInfo(0, ["Resources/Images/ScrollBarThumb.png",
		"Resources/Images/ScrollBarThumb.png", "Resources/Images/ScrollBarThumb.png"]);
	scroller1.width = 4;
	scroller2.setTrackInfo(0, 0, 0, "Resources/Images/ScrollBarTrack.png");
	scroller2.setThumbInfo(0, ["Resources/Images/ScrollBarThumb.png",
		"Resources/Images/ScrollBarThumb.png", "Resources/Images/ScrollBarThumb.png"]);
	scroller2.width = 4;
}

function showWindowButtons()
{
	var a = new FadeAnimation(close_button, 255, 300, animator.kEaseIn);
	var b = new FadeAnimation(minimise_button, 255, 300, animator.kEaseIn);
	
	animator.start([a, b]);
}

function hideWindowButtons()
{
	var a = new FadeAnimation(close_button, 0, 300, animator.kEaseOut);
	var b = new FadeAnimation(minimise_button, 0, 300, animator.kEaseOut);
	
	animator.start([a, b]);
}

function resize()
{
	var percent = (animator.milliseconds - this.startTime) / this.duration * 100;
	var unit = (this.endSize - this.startSize) / 100.0;
	
	if (percent <= 100)
	{
		this.object.height = this.object.width = this.startSize + percent * unit;
		this.object.hRegistrationPoint = this.object.vRegistrationPoint =
			(this.startSize + percent * unit) / 2.0;
		return true;
	}
	else
	{
		this.object.height = this.object.width = this.endSize;
		this.object.hRegistrationPoint = this.object.vRegistrationPoint =
			this.endSize / 2;
		return false;
	}
}

function minimise()
{
	isMinimised = true;
	
	if (isDown1)
		hideLanguagePanel1();
	else if (isDown2)
		hideLanguagePanel2();
	else if (isDownServices)
		hideServicesPanel();
	
	var a = new FadeAnimation(background, 0, 300, animator.kEaseOut);
	var b = new FadeAnimation(languagebar1, 0, 300, animator.kEaseOut);
	var c = new FadeAnimation(languagebar2, 0, 300, animator.kEaseOut);
	var d = new FadeAnimation(languageText1, 0, 300, animator.kEaseOut);
	var e = new FadeAnimation(languageText2, 0, 300, animator.kEaseOut);
	var f = new FadeAnimation(rightArrow, 0, 300, animator.kEaseOut);
	var g = new FadeAnimation(leftArrow, 0, 300, animator.kEaseOut);
	var h = new FadeAnimation(text1, 0, 300, animator.kEaseOut);
	var i = new FadeAnimation(text2, 0, 300, animator.kEaseOut);
	var j = new FadeAnimation(minimised, 255, 300, animator.kEaseOut);
	var k = new FadeAnimation(minimise_button, 0, 300, animator.kEaseOut);
	var l = new FadeAnimation(close_button, 0, 300, animator.kEaseOut);
	
	var shrink = new CustomAnimation(10, resize);
	shrink.duration = 300;
	shrink.object = earth;
	shrink.startSize = 88;
	shrink.endSize = 52;
	
	animator.runUntilDone([a, b, c, d, e, f, g, h, i, j, k, l, shrink]);
	minimise_button.visible = close_button.visible = false;
	minimised.slide("right", 100, 3);
	
	// Disable the earth's actions so that it can be used as
	// a handle for dragging the Widget.
	earth.onMouseUp = null;
	earth.tooltip = "";
	earth.onMouseEnter = null;
	earth.onMouseExit = null;
	
	preferences.minimised.value = "true";
}

function restore()
{
	isMinimised = false;
	
	if (isDown1)
		hideLanguagePanel1();
	else if (isDown2)
		hideLanguagePanel2();
	else if (isDownServices)
		hideServicesPanel();
	
	minimised.slide("left", 100, 3);
	
	minimise_button.visible = close_button.visible = true;
	
	var a = new FadeAnimation(background, 255, 300, animator.kEaseOut);
	var b = new FadeAnimation(languagebar1, 255, 300, animator.kEaseOut);
	var c = new FadeAnimation(languagebar2, 255, 300, animator.kEaseOut);
	var d = new FadeAnimation(languageText1, 255, 300, animator.kEaseOut);
	var e = new FadeAnimation(languageText2, 255, 300, animator.kEaseOut);
	var f = new FadeAnimation(rightArrow, 255, 300, animator.kEaseOut);
	var g = new FadeAnimation(leftArrow, 255, 300, animator.kEaseOut);
	var h = new FadeAnimation(text1, 255, 300, animator.kEaseOut);
	var i = new FadeAnimation(text2, 255, 300, animator.kEaseOut);
	var j = new FadeAnimation(minimised, 0, 300, animator.kEaseOut);
	var k = new FadeAnimation(minimise_button, 255, 300, animator.kEaseOut);
	var l = new FadeAnimation(close_button, 255, 300, animator.kEaseOut);
	
	var grow = new CustomAnimation(10, resize);
	grow.duration = 300;
	grow.object = earth;
	grow.startSize = 52;
	grow.endSize = 88;
	
	animator.start([a, b, c, d, e, f, g, h, i, j, k, l, grow]);
	
	// Restore the earth's previous actions.
	earth.onMouseUp = earthAction;
	earth.tooltip = "Click to change translation service.";
	earth.onMouseEnter = "earth.hslAdjustment = '0, 0, 10'";
	earth.onMouseExit = "earth.hslAdjustment = '0, 0, 0'";
	
	preferences.minimised.value = "false";
}