function SDLInternationalTranslationService()
{
	var dictionary = new Array();
	var updateFunction;
	
	SDLInternationalTranslationService.prototype.getLanguageDictionary = 
		getLanguageDictionary;
	SDLInternationalTranslationService.prototype.translate = translate;
	
	// Initialise the dictionary array.
	dictionary["Chinese (Simplified)"] = ["SimplifiedChinese", []];
	dictionary["Chinese (Traditional)"] = ["TraditionalChinese", []];
	dictionary["Dutch"] = ["Dutch", ["English"]];
	dictionary["English"] = ["English", ["Chinese (Simplified)",
		"Chinese (Traditional)", "Dutch", "French", "German", "Italian",
		"Japanese", "Norwegian", "Portuguese", "Russian", "Spanish"]];
	dictionary["French"] = ["French", ["English"]];
	dictionary["German"] = ["German", ["English"]];
	dictionary["Italian"] = ["Italian", ["English"]];
	dictionary["Japanese"] = ["Japanese", ["English"]];
	dictionary["Norwegian"] = ["Norwegian", []];
	dictionary["Portuguese"] = ["Portuguese", ["English"]];
	dictionary["Russian"] = ["Russian", ["English"]];
	dictionary["Spanish"] = ["Spanish", ["English"]];
	
	function getLanguageDictionary()
	{
		return dictionary;
	}
	
	function translate(fromLanguage, toLanguage, text, update)
	{
		updateFunction = update;
		
		var url = new URL();
		if (fromLanguage == "Chinese (Simplified)" ||
			toLanguage == "Chinese (Simplified)" ||
			fromLanguage == "Chinese (Traditional)" ||
			toLanguage == "Chinese (Traditional)" ||
			fromLanguage == "Russian" || toLanguage == "Russian")
		{
			url.location = "http://ets6.freetranslation.com/";
		}
		else if (fromLanguage == "Japanese" || toLanguage == "Japanese")
			url.location = "http://tets9.freetranslation.com/";
		else		
			url.location = "http://ets.freetranslation.com/";
		
		var language = dictionary[fromLanguage][0] + "%2F" + dictionary[toLanguage][0];
		var srctext = escape(text);
		
		url.postData = "sequence=core&mode=html&charset=UTF-8&template=results_en-us.htm" +
			"&language=" + language + "&srctext=" + srctext;
		url.fetchAsync(urlDone);
	}
	
	function urlDone(url)
	{
		if (url.response != 0 && url.response < 400)
		{
			page = url.result;
			
			var startPosition =
				page.indexOf("<textarea name=\"dsttext\" cols=\"40\" rows=\"6\">") + 44;
			var endPosition = page.indexOf("</textarea>", startPosition + 1);
			var translatedText = page.substring(startPosition, endPosition);
			
			updateFunction(translatedText);
		}
		else
		{
			alert("There was an error while connecting to the server. Please " +
				"check your Internet connection before trying again.");
			
			updateFunction("");
		}
		
		delete url;
	}
}