function SystranTranslationService()
{
	var dictionary = new Array();
	
	SystranTranslationService.prototype.getLanguageDictionary = 
		getLanguageDictionary;
	SystranTranslationService.prototype.translate = translate;
	
	// Initialise the dictionary array.
	dictionary["Arabic"] = ["ar", ["English"]];
	dictionary["Chinese (Simplified)"] = ["zh", ["English"]];
	dictionary["Chinese (Traditional)"] = ["zt", ["English"]];
	dictionary["English"] = ["en", ["Arabic", "Chinese (Simplified)",
		"Chinese (Traditional)", "Dutch", "French", "German", "Italian",
		"Japanese", "Korean", "Portuguese", "Russian", "Spanish", "Swedish"]];
	dictionary["Dutch"] = ["nl", ["English", "French"]];
	dictionary["French"] = ["fr", ["Dutch", "English", "German", "Italian",
		"Portuguese", "Spanish"]];
	dictionary["German"] = ["de", ["English", "French"]];
	dictionary["Italian"] = ["it", ["English", "French"]];
	dictionary["Japanese"] = ["ja", ["English"]];
	dictionary["Korean"] = ["ko", ["English"]];
	dictionary["Portuguese"] = ["pt", ["English", "French"]];
	dictionary["Russian"] = ["ru", ["English"]];
	dictionary["Spanish"] = ["es", ["English", "French"]];
	dictionary["Swedish"] = ["sv", ["English"]];
	
	function getLanguageDictionary()
	{
		return dictionary;
	}
	
	function translate(fromLanguage, toLanguage, text, update)
	{
		updateFunction = update;
		
		var url = new URL();
		url.location = "http://www.systranbox.com/systran/box";
		
		var systran_lp = dictionary[fromLanguage][0] + "_" + dictionary[toLanguage][0];
		var systran_text = escape(text);
		
		url.postData = "systran_id=SystranSoft-en&systran_charset=UTF-8&ttype=" +
			"text&systran_text=" + systran_text + "&systran_url=_&systran_lp=" +
			systran_lp;
		url.fetchAsync(urlDone);
	}
	
	function urlDone(url)
	{
		if (url.response != 0 && url.response < 400)
		{
			page = url.result;
			
			var startPosition =
				page.indexOf("<textarea name=\"translation\" rows=\"7\" cols=\"20\">") + 48;
			var endPosition = page.indexOf("</textarea>", startPosition + 1);
			var translatedText = page.substring(startPosition, endPosition);
			
			updateFunction(translatedText);
		}
		else
		{
			alert("There was an error while connecting to the server. Please " +
				"check your Internet connection before trying again.");
			
			updateFunction("");
		}
		
		delete url;
	}
}